<?php

/**
  Great Quotes Management Class

  This class allows the user to add, edit, and delete quotes, and also displays the options page.

 */
//  if( !class_exists('Great_Quotes_Management') ) :

class Great_Quotes_Management {

    var $pluginPath;
    var $pluginFile;
    var $tableName;

    /** set some basic variables  */
    function Great_Quotes_Management() {
        global $wpdb;

        $this->pluginPath = plugin_dir_path(__FILE__);
        $this->pluginFile = $this->pluginPath . 'great-quotes.php';
        $this->tableName = $wpdb->prefix . 'Great_Quotes';
    }

    /** add a new quote to the table  */
    function addQuote($quote, $author) {
        global $wpdb;

        $quote = str_replace(array("\r\n", "\r", "\n"), "<br />", $quote);
        $quote = str_replace("\"", "'", $quote);

        $author = str_replace(array("\r\n", "\r", "\n"), "<br />", $author);
        $author = str_replace("\"", "'", $author);

        $category = str_replace(array("\r\n", "\r", "\n"), "<br />", $category);
        $category = str_replace("\"", "'", $category);

        $sql = "INSERT INTO " . $this->tableName . " (quote, author) VALUES ('" . addslashes($quote) . "', '" . addslashes($author) . "');";
        $wpdb->query($sql);
    }

    /** edit a quote already on the table  */
    function editQuote($quote, $author, $id) {
        global $wpdb;

        $quote = str_replace(array("\r\n", "\r", "\n"), "<br />", $quote);
        $quote = str_replace("\"", "'", $quote);

        $author = str_replace(array("\r\n", "\r", "\n"), "<br />", $author);
        $author = str_replace("\"", "'", $author);
        $sql = "UPDATE `" . $this->tableName . "` SET `quote`='" . addslashes($quote) . "', `author`='" . addslashes($author) . "' WHERE `id`=" . $id . ";";
	$sql = "UPDATE `" . $this->tableName . "` SET `quote`='" . addslashes($quote) . "', `author`='" . addslashes($author) . "', `category`='" . addslashes($category) . "' WHERE `id`=".$id.";";

        $wpdb->query($sql);
    }

    /** delete a quote already on the  table  */
    function deleteQuote($id) {
        global $wpdb;

        $sql = "DELETE FROM " . $this->tableName . " WHERE id=" . $id;
        $wpdb->query($sql);
    }

    /** display all  the quotes on the Tools page  */
    function displayQuotes() {
        global $wpdb;
        $sql = "SELECT * FROM " . $this->tableName . " ORDER BY id";
        $results = $wpdb->get_results($sql);
        echo "<table class=\"widefat\">\n";
        echo "\t<thead>\n";
        echo "\t\t<tr>\n";
        echo "\t\t\t<th scope=\"col\" style=\"text-align:center;\">ID</th>\n";
        echo "\t\t\t<th scope=\"col\">Quote</th>\n";
        echo "\t\t\t<th scope=\"col\">Author</th>\n";
        echo "\t\t\t<th scope=\"col\" colspan=\"2\" style=\"text-align:center;\">Action</th>\n";
        echo "\t\t</tr>\n";
        echo "\t</thead>\n";
        echo "\t<tbody id=\"the-list\">\n";

        $i = 0;
        foreach ($results as $result) {
            if ($i % 2 == 0)
                $class = "alternate";
            else
                $class = "";
            echo "\t\t<tr id=\"quote-" . $result->id . "\" class=\"" . $class . "\">\n";
            echo "\t\t\t<th scope=\"row\" style=\"text-align:center;\">" . $result->id . "</th>\n";
            echo "\t\t\t<td>" . stripslashes($result->quote) . "</td>\n";
            echo "\t\t\t<td>" . stripslashes($result->author) . "</td>\n";
            echo "\t\t\t<td style=\"text-align:center;\"><a class=\"edit\" href=\"" . get_option('siteurl') . "/wp-admin/edit.php?page=great-quotes.php&amp;action=edit&amp;id=" . $result->id . "\">Edit</a></td>\n";
            $delURL = wp_nonce_url(get_option('siteurl') . "/wp-admin/edit.php?page=great-quotes.php&amp;action=delete-quote&amp;id=" . $result->id, 'fqr-nonce');
            echo "\t\t\t<td style=\"text-align:center;\"><a class=\"delete\" href=\"" . $delURL . "\">Delete</a></td>\n";
            echo "\t\t</tr>\n";
            $i++;
        }

        echo "\t</tbody>\n";
        echo "</table>\n\n";
    }

    /** retreive the quote to be edited or added and displayed on Tools page  */
    function displayManagementPage() {
        global $wpdb;

        echo "\t\t<div class=\"wrap\">\n";
        if ($_GET['action'] == 'edit') {
            $sql = "SELECT * FROM `" . $this->tableName . "` WHERE `id` = " . intval($_GET['id']);
            $results = $wpdb->get_results($sql);
            $r = $results[0];
            echo "\t\t\t<h2>Edit Quote</h2>\n";
            echo "\t\t\t<form name=\"EditQuotesForm\" method=\"post\" action=\"?page=great-quotes.php\">\n";
            wp_nonce_field('fqr-nonce');
            echo "\t\t\t\t<p class=\"submit\">\n";
            echo "\t\t\t\t\t<input type=\"submit\" name=\"submit\" value=\"Update Quote &raquo;\" />\n";
            echo "\t\t\t\t</p>\n";
            echo "\t\t\t\t<table class=\"editform\" width=\"100%\" cellspacing=\"2\" cellpadding=\"5\">\n";
            echo "\t\t\t\t\t<tr>\n";
            echo "\t\t\t\t\t\t<th width=\"33%\" scope=\"row\" valign=\"top\"><label for=\"quote\">Quote:</label></th>\n";
            echo "\t\t\t\t\t\t<td width=\"67%\"><textarea name=\"quote\" style=\"width:350px;height:200px;\"/>" . stripslashes($r->quote) . "</textarea></td>\n";
            echo "\t\t\t\t\t</tr>\n";
            echo "\t\t\t\t\t<tr>\n";
            echo "\t\t\t\t\t\t<th width=\"33%\" scope=\"row\" valign=\"top\"><label for=\"author\">Author:</label></th>\n";
            echo "\t\t\t\t\t\t<td width=\"67%\"><input type=\"text\" name=\"author\" style=\"width:350px;\" value=\"" . stripslashes($r->author) . "\"/></td>\n";
            echo "\t\t\t\t\t<tr>\n";
            echo "\t\t\t\t\t\t<th width=\"33%\" scope=\"row\" valign=\"top\"><label for=\"category\">Category:</label></th>\n";
            echo "\t\t\t\t\t\t<td width=\"67%\"><input type=\"text\" name=\"category\" style=\"width:350px;\" value=\"" . stripslashes($r->category) . "\"/></td>\n";
            echo "\t\t\t\t\t</tr>\n";
            echo "\t\t\t\t</table>\n";
            echo "\t\t\t\t<input type=\"hidden\" name=\"editQuote\" value=\"1\" />\n";
            echo "\t\t\t\t<input type=\"hidden\" name=\"id\" value=\"" . $r->id . "\" />\n";
            echo "\t\t\t\t<p class=\"submit\">\n";
            echo "\t\t\t\t\t<input type=\"submit\" name=\"submit\" value=\"Update Quote &raquo;\" />\n";
            echo "\t\t\t\t</p>\n";
            echo "\t\t\t</form>\n";
        } else {
            echo "\t\t\t<h2>Quotes</h2>\n";
            $this->displayQuotes();
            echo "\t\t\t<br /><br />\n";
            echo "\t\t\t<h2>Add Quote</h2>\n";
            echo "\t\t\t<form name=\"QuotesForm\" method=\"post\" action=\"\">\n";
            wp_nonce_field('fqr-nonce');
            echo "\t\t\t\t<p class=\"submit\">\n";
            echo "\t\t\t\t\t<input type=\"submit\" name=\"submit\" value=\"Add Quote &raquo;\" />\n";
            echo "\t\t\t\t</p>\n";
            echo "\t\t\t\t<table class=\"editform\" width=\"100%\" cellspacing=\"2\" cellpadding=\"5\">\n";
            echo "\t\t\t\t\t<tr>\n";
            echo "\t\t\t\t\t\t<th width=\"33%\" scope=\"row\" valign=\"top\" align=\"right\"><label for=\"quote\">Quote (< 175 characters recommended unless you know CSS):</label></th>\n";
            echo "\t\t\t\t\t\t<td width=\"67%\"><textarea name=\"quote\" style=\"width:350px;height:100px;\"/></textarea></td>\n";
            echo "\t\t\t\t\t</tr>\n";
            echo "\t\t\t\t\t<tr>\n";
            echo "\t\t\t\t\t\t<th width=\"33%\" scope=\"row\" valign=\"top\" align=\"right\"><label for=\"author\">Author (first name last name no commas):</label></th>\n";
            echo "\t\t\t\t\t\t<td width=\"67%\"><input type=\"text\" name=\"author\" style=\"width:350px;\"/></td>\n";
            echo "\t\t\t\t\t</tr>\n";
            echo "\t\t\t\t\t<tr>\n";
            echo "\t\t\t\t\t\t<th width=\"33%\" scope=\"row\" valign=\"top\" align=\"right\"><label for=\"category\">Category (currently not used):</label></th>\n";
            echo "\t\t\t\t\t\t<td width=\"67%\"><input type=\"text\" name=\"category\" style=\"width:350px;\"/></td>\n";
            echo "\t\t\t\t\t</tr>\n";
            echo "\t\t\t\t</table>\n";
            echo "\t\t\t\t<input type=\"hidden\" name=\"addQuote\" value=\"1\" />\n";
            echo "\t\t\t\t<p class=\"submit\">\n";
            echo "\t\t\t\t\t<input type=\"submit\" name=\"submit\" value=\"Add Quote &raquo;\" />\n";
            echo "\t\t\t\t</p>\n";
            echo "\t\t\t</form>\n";
        }
        echo "\t\t</div>\n";
    }

    /** display the shortcode options pages under the Setting Menu  */
    function displayOptionsPage() {
        if ($_POST['action'] == 'update' && check_admin_referer('fqr-nonce')) {
            $sanp_gq_title = sanitize_text_field($_POST['gq_title']);
            $sanp_gq_delay = sanitize_text_field($_POST['gq_delay']);
//            $sanp_gq_width = sanitize_text_field($_POST['gq_width']);
            $sanp_gq_fontsize = sanitize_text_field($_POST['gq_fontsize']);
            $sanp_gq_textcolor = sanitize_text_field($_POST['gq_textcolor']);

            update_option('gq_title', $sanp_gq_title);
            update_option('gq_delay', $sanp_gq_delay);
//            update_option('gq_width', $sanp_gq_width);
            update_option('gq_fontsize', $sanp_gq_fontsize);
            update_option('gq_textcolor', $sanp_gq_textcolor);
            ?><div class="updated"><p><strong><?php _e('Options saved.', 'eg_trans_domain'); ?></strong></p></div><?php
        }
        ?>
        <div class="wrap">
            <h2>Great Quotes Shortcut Options</h2>

            <form method="post">
        <?php wp_nonce_field('fqr-nonce'); ?>

                <table class="form-table">
                    <tr valign="top">
                        <th scope="row">Title</th>
                        <td><input type="text" name="gq_title" value="<?php echo get_option('gq_title'); ?>" /></td>
                        <td rowspan="5" style="padding-left: 20px;">
                            <h2>Usage:</h2>
                            <ul>
                                <li>To edit quotations, go to Tools &gt; Great Quotes</li>
                                <li>To display Great Quotes on a web page:</li>
                            </ul>
                            <blockquote>
                                <ol>
                                    <li>Add a shortcode to your page or post content. Note that the settings entered on this page will be the default for every page with a shortcut. <br />
                                        <!--<code>[GreatQuotes title="{optional title}" delay="{delay in milliseconds, optional}" fontsize="{optional}" textcolor="{optional}"]" </code><br />-->
                                        <code>[GreatQuotes title="{optional title}" delay="{delay in milliseconds, optional}" fontsize="{optional}" textcolor="{optional}"]" </code><br />
                                        e.g.1: <code>[GreatQuotes]</code><br />
                                        e.g.2: <code>[GreatQuotes title="Great Quotes" delay="20000"]</code>  </li>
                                        The values entered on the left will be the defaults unless overridden in the shortcode.
                                    
                                    <li> Attach a widget to a sidebar(Appearance &gt; Widgets)</li>
                                </ol>
                            </blockquote>
                        </td>
                    </tr>

                    <tr valign="top">
                        <th scope="row">Delay (in seconds)</th>
                        <td><input type="text" name="gq_delay" value="<?php echo get_option('gq_delay'); ?>" /></td>
                    </tr>

<!--                    <tr valign="top">
                        <th scope="row">Width override (overrides CSS)</th>
                        <td><input type="text" name="gq_width" value="<?php echo get_option('gq_width'); ?>" />px</td>
                    </tr>-->

                    <tr valign="top">
                        <th scope="row">Font Size override (overrides CSS)</th>
                        <td><input type="text" name="gq_fontsize" value="<?php echo get_option('gq_fontsize'); ?>" /></td>
                    </tr>

                    <tr valign="top">
                        <th scope="row">Text Color override (overrides CSS)</th>
                        <td><input type="text" name="gq_textcolor" value="<?php echo get_option('gq_textcolor'); ?>" /></td>
                    </tr>
                </table>          

                <input type="hidden" name="action" value="update" />
                <!--<input type="hidden" name="page_options" value="gq_title,gq_delay,gq_width,gq_fontsize,gq_textcolor" />-->
                <input type="hidden" name="page_options" value="gq_title,gq_delay,gq_fontsize,gq_textcolor" />


                <p class="submit">
                    <input type="submit" name="Submit" value="<?php _e('Save Changes') ?>" />
                </p>

            </form>
        </div>
        <?php
    }

}