<?php

/**
  Great Quotes Widget Class

  This class is reponsible for displaying and updating the widget(s) added via Appearance>Widgets.
 
 */
class Great_Quotes_widget extends WP_Widget {

    function Great_Quotes_widget() {
        parent::WP_Widget(false, $name = 'Great Quotes');
    }

    /** @see WP_Widget::widget -- get  form values and create javascript code */
    function widget($args, $instance) {
        extract($args);
        $title = apply_filters('widget_title', $instance['title']);
        $delay = $instance['delay'];
        $fontsize = $instance['fontsize'];
        $textcolor = $instance['textcolor'];
        $title = $instance['title'];
        ?>

        <?php
        if ($delay <= 0) {
            $delay = 20000;
        }

        if ($fontsize <= 0) {
            $fontsize = 15;
        }

        if ($textcolor == "") {
            $textcolor = "black";
        }

        $style = "";
        if ($fontsize != "") {
            $style .= "font-size:" . $fontsize . "px" . ";";
        }

        if ($textcolor != "") {
            $style .= "color:" . $textcolor . ";";
        }
        if ($style != "") {
            $style = " style='" . $style . "'";
        }

        echo $before_widget . $before_title;
        if ($textcolor != "")
            $titlestyle .= "color:" . $textcolor . ";";

        if ($titlestyle != "")
            $titlestyle = " style='" . $titlestyle . "'";
        $widgetid = $this->id;
        $h4widgetclass = $widgetid;
        if (isset($title) && $title != "") {
              echo "<" . "h4" . " " . "class=" . '"' . $h4widgetclass . '"' .  ">" . $title . "</h4>";
        } else {
            $title_from_settings = get_option('fqr_title');
            if (isset($title_from_settings) && $title_from_settings != "") {
                echo "<" . "h4" . " " . "class=" . '"' . $h4widgetclass . '"' .  ">" . $title . "</h4>";
            }
        }

        global $wpdb;
        $widgetid = $args['widget_id'];

        //  the "-" causes a javacript error
        $widgetid = str_replace("-", "_", "$widgetid");
        $classbxslider  = "bxslider" . $widgetid;
        $divbxslider  = "bxslider" . $widgetid;
        $divsilder_holder = "Silder_holder" . $widgetid;

        $this->tableName = $wpdb->prefix . 'Great_Quotes';

        $sql = "SELECT * FROM " . $this->tableName . " ORDER BY RAND() " . "LIMIT 200";

        $results = $wpdb->get_results($sql);
        echo "	<script type='text/javascript'>";
        echo "  jQuery(document).ready(function(){ 
               jQuery('.$classbxslider').bxSlider({
                autostart: true,
                pause: $delay,
                auto: true,
                pager: false,
                adaptiveHeight: false,
                autoHover: true,
                mode: 'fade',
                onSliderLoad: function(){
                jQuery('#$divsilder_holder').css('visibility', 'visible')
                }
              });
             });";
        echo "</script>";

       echo "<div id='$divsilder_holder' style='visibility: hidden'>";

        echo "  <div class='$divbxslider'>";
        $i = 1;
        foreach ($results as $result) {
            echo "<div" . $style . ">";
            $thequote = str_replace('\\', '', $result->quote);
            echo "$thequote<br/>";
            echo "<div><span style='padding-top: 5px;padding-bottom: 100px;float: right;font-style: italic;'>";
            echo "<a href='https://en.wikipedia.org/wiki/" . $result->author . "'" . " " . "target='_blank'" . " " . "style='text-decoration:underline'" . ">" . $result->author . "</a></span></div></div>";
            $i++;
        }
        echo "   </div>";
        echo " </div>";
        echo $after_widget;
    }

    /** @see WP_Widget::update -- save data  from  widget form  */
    function update($new_instance, $old_instance) {
        $instance = $old_instance;
        $instance['title'] = strip_tags($new_instance['title']);
        $instance['delay'] = strip_tags($new_instance['delay']);
        $instance['fontsize'] = strip_tags($new_instance['fontsize']);
//        $instance['width'] = strip_tags($new_instance['width']);
        $instance['textcolor'] = strip_tags($new_instance['textcolor']);
        return $instance;
    }

    /** @see WP_Widget::form -- display  widget  form */
    function form($instance) {

        $title = esc_attr($instance['title']);
        $delay = esc_attr($instance['delay']);
        $fontsize = esc_attr($instance['fontsize']);
        $textcolor = esc_attr($instance['textcolor']);
        ?>
        <p>
            <label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title (optional):'); ?></label> 
            <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" />
        </p>
        <p>
            <label for="<?php echo $this->get_field_id('delay'); ?>"><?php _e('Delay (miliseconds - default= 20000):'); ?></label> 
            <input class="widefat" id="<?php echo $this->get_field_id('delay'); ?>" name="<?php echo $this->get_field_name('delay'); ?>" type="text" value="<?php echo $delay; ?>" />
            <label for="<?php echo $this->get_field_id('fontsize'); ?>"><?php _e('Font Size (< 20 recommended - default 15):'); ?></label> 
            <input class="widefat" id="<?php echo $this->get_field_id('fontsize'); ?>" name="<?php echo $this->get_field_name('fontsize'); ?>" type="text" value="<?php echo $fontsize; ?>" />
            <label for="<?php echo $this->get_field_id('textcolor'); ?>"><?php _e('Text Color:'); ?></label> 
            <input class="widefat" id="<?php echo $this->get_field_id('textcolor'); ?>" name="<?php echo $this->get_field_name('textcolor'); ?>" type="text" value="<?php echo $textcolor; ?>" />

        <?php ?>
        </p>

        <?php
    }
}

// end class flexi_quote_plus_widget
add_action('widgets_init', create_function('', 'return register_widget("Great_Quotes_widget");'));