<?php

/*
This class creates the database tables when the plugin is initiated, and deletes the options when deactivated.  

*/

if( !class_exists('Great_Quotes') ) :

class Great_Quotes
{
	var $tableName;
	var $pluginPath;
	var $currentVersion;
	
	function Great_Quotes()
	{
		global $wpdb;
		$this->currentVersion = '1.0.0';
		$this->tableName = $wpdb->prefix . 'Great_Quotes';
	        $this->pluginPath = plugin_dir_path( __FILE__ );
		$options = get_option('widgetGreatQuotes');
		$options['version'] = $this->currentVersion;
		update_option('widgetGreat_Quotes', $options);
	}
	
	function createDatabaseTable()
	{
		global $wpdb;
		$options = array();
		$options['title'] = 'Great Quotes';
		$options['delay'] = 20000;
		$options['fontsize'] = 15;
                $options['textcolor'] = "black";
		
		if( !get_option('widgetGreat_Quotes') )
		{
		  add_option('widgetGreat_Quotes', $options);
		}
		
		if( $wpdb->get_var("SHOW TABLES LIKE `" . $this->tableName . "`") != $this->tableName)
		{
		 $sql = "CREATE TABLE `" . $wpdb->prefix . "Great_Quotes` (`id` MEDIUMINT(9) NOT NULL AUTO_INCREMENT PRIMARY KEY, `quote` TEXT NULL);";
	
		 require_once(ABSPATH . 'wp-admin/upgrade-functions.php');
		
                 dbDelta($sql);
		
		 $options['version'] = $this->currentVersion;
		}
	
		$sql = "ALTER TABLE `" . $this->tableName . "` ADD `author` VARCHAR(255) NOT NULL AFTER `quote`;";
		$wpdb->query($sql);

		$sql = "ALTER TABLE `" . $this->tableName . "` ADD `category` VARCHAR(255) NOT NULL AFTER `author`;";
		$wpdb->query($sql);
		
		$sql = "RENAME TABLE `wp_Great_Quotes` TO `$this->tableName`;";
		$wpdb->query($sql);
		
		$sql = "ALTER TABLE `" . $this->tableName . "` CHANGE `quote` `quote` TEXT NULL;";
		$wpdb->query($sql);
		
		$sql = "ALTER TABLE `" . $this->tableName . "` CHANGE `category` `category` TEXT NULL;";
		$wpdb->query($sql);
                
                $my_path = plugin_dir_path( __FILE__ );
                $my_file = "QuotesAll.csv";
                $path_to_file = $my_path . $my_file;
                
		$sql = 'LOAD DATA LOCAL INFILE'  . ' ' . "'" . $path_to_file . "'" . ' '  . 'INTO TABLE' . ' ' .  $this->tableName . ' '  . 'FIELDS TERMINATED BY' . ' ' . "'" . ';' . "'";
	
                $wpdb->query($sql);
		
		update_option('widgetGreat_Quotes', $options);
	}
	
	function deleteDatabaseTable()
	{   
//	    delete_option('widgetGreat_Quotes');
//            global $wpdb;
//	    $sql = "DROP TABLE IF EXISTS " . "wp_Great_Quotes" . " ;";	
//            $wpdb->query($sql);
	}
}

endif;
?>
