<?php
/*
  Plugin Name: Great Quotes
  Plugin URI: http://stevelescure.net/qood-quotes/
  Description: Randomly display quotations from a database of about 20,000 quotes. Supports multiple widgets and shortcodes. Responsive.
  .
  Version: 1.0.0
  Author:  Steve Lescure
  Author URI: http://www.stevelescure.net/great-quotes

  ---------------------------------e------------------------------------
  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
  ---------------------------------------------------------------------
 */

require_once('classes/great-quotes.class.php');
require_once('classes/great-quotes-management.class.php');
require_once('classes/great-quotes-widget.class.php');

if (class_exists('Great_Quotes') && class_exists('Great_Quotes_Management')) :

    $gq_quoteRotator = new Great_Quotes();
    $gq_management = new Great_Quotes_Management();
    if (isset($gq_quoteRotator) && isset($gq_management)) {

        function gq_process_post() {
            global $gq_quoteRotator, $gq_management;
            $action = (isset($_GET['action']) ? $_GET['action'] : null);
            $addQuote = (isset($_POST['addQuote']) ? $_POST['addQuote'] : null);
            $editQuote = (isset($_POST['editQuote']) ? $_POST['editQuote'] : null);

            if ($action == "delete-quote" && check_admin_referer('fqr-nonce')) {
                $gq_management->deleteQuote($_GET['id']);
            }

            if ($addQuote == 1 && check_admin_referer('fqr-nonce')) {
                $gq_management->addQuote($_POST['quote'], $_POST['author']);
            }

            if ($editQuote == 1 && check_admin_referer('fqr-nonce')) {
                $gq_management->editQuote($_POST['quote'], $_POST['author'], $_POST['id']);
            }
        }

        function gq_widgetInit() {
            global $gq_quoteRotator, $gq_management;

            if (!function_exists('wp_register_sidebar_widget')) {
                return;
            }
        }

        function gq_managementInit() {
            global $gq_management;
            add_management_page('Great Quotes', 'Great Quotes', 5, basename(__FILE__), array(&$gq_management, 'displayManagementPage'));
            add_options_page('Great Quotes', 'Great Quotes', 10, basename(__FILE__), array(&$gq_management, 'displayOptionsPage'));
        }

        function gq_includejquery() {
            wp_register_style('bxslidercss', plugins_url('css/jquery.bxslider.css', __FILE__));
            wp_enqueue_style('bxslidercss');
            wp_register_style('GreatQuotescss', plugins_url('css/greatquotes.css', __FILE__));
            wp_enqueue_style('GreatQuotescss');
            wp_enqueue_script('jquery');
            wp_enqueue_script('bxscript', plugins_url('/js/jquery.bxslider.min.js' , __FILE__), array('jquery'));
        }

        function gq_GreatQuotes_func($atts) {
            global $gq_quoteRotator;
            global $wpdb;
            extract(shortcode_atts(array(
                'title' => '',
                'delay' => '',
                'fontsize' => '',
                'textcolor' => '',
                            ), $atts));
//                'width' => '',
            // used to  count the number of shortcodes entered  on a page      
            global $shortcodecnt;
            $shortcodecnt = $shortcodecnt + 1;
            $classbxslider  = ".bxslider" . $shortcodecnt;
            $divbxslider  = "bxslider" . $shortcodecnt;
            $divsilder_holder = "Silder_holder" . $shortcodecnt;

            //  set parms to the default if not set in shortcode

            if ($title == "") {
                $title = get_option('gq_title');
            }

            if ($delay <= 0) {
                $delay = get_option('gq_delay');
            }
 
            if ($delay <= 0) {
                $delay = 20000;
            }

            if ($fontsize <= 0) {
                $fontsize = get_option('gq_fontsize');
            }

            if ($fontsize <= 0) {
                $fontsize = 15;
            }

            if ($textcolor == "") {
                $textcolor = get_option('gq_textcolor');
            }

            if ($textcolor == "") {
                $textcolor = get_option('textcolor');
            }

            if ($title == "") {
                $title = get_option('title');
            }

            $results = $wpdb->get_results($sql);

            $style = "padding-top: 10px; padding-left: 10px;";
            if ($fontsize != "") {
                $style .= "font-size:" . $fontsize . "px" . ";";
            }
            if ($textcolor != "") {
                $style .= "color:" . $textcolor . ";";
            }
            if ($style != "") {
                $style = " style='" . $style . "'";
            }
            if ($textcolor != "") {
                $titlestyle .= "color:" . $textcolor . ";";
            }
            if ($width != "") {
                $titlestyle .= "width:" . $width . "px" . ";";
            }
            
            $titlestyle = $titlestyle  . "margin-bottom: 0px;";
            
            if ($titlestyle != "") {
                $titlestyle = " style='" . $titlestyle . "'";            
            }
            
            $h4class = "h4class" . $shortcodecnt;

            if (isset($title) && $title != "") {
                $out = "<h4 class='{$h4class}'>$title</h4>" . "\n";
                } else {
                $title_from_settings = get_option('gq_title');
                if (isset($title_from_settings) && $title_from_settings != "") {
                   $out = "<h4 class='{$h4class}'>$title'</h4>" . "\n";
                   }
            }

            global $wpdb;
            $tableName = $wpdb->prefix . 'Great_Quotes';
            $sql = "SELECT * FROM " . $tableName . " ORDER BY RAND() " . "LIMIT 200";

            $results = $wpdb->get_results($sql);
            
           $out .= " <script type='text/javascript'>"                   . "\n";
           $out .= "  jQuery(document).ready(function(){"               . "\n";
           $out .= "  jQuery('$classbxslider').bxSlider({"              . "\n";
           $out .= "    autostart: true,                 "              . "\n";
           $out .= "    pause: $delay,                   "              . "\n";   
           $out .= "    auto: true,                      "              . "\n";
           $out .= "    pager: false,                    "              . "\n";
           $out .= "    adaptiveHeight: false,           "              . "\n";
           $out .= "    autoHover: true,                 "              . "\n";
           $out .= "    mode: 'fade',                    "              . "\n";
           $out .= "    onSliderLoad: function(){        "              . "\n";
           $out .= "     jQuery('#$divsilder_holder').css('visibility', 'visible');          "  . "\n";
           $out .= "      }"                                            . "\n";
           $out .= "     })"                                            . "\n";
           $out .= "   });"                                             . "\n";
           $out .= "</script>"                                          . "\n";
           $out .= "<div id='$divsilder_holder' style='visibility: hidden'> "  . "\n";
           $out .=  "  <div class='{$divbxslider}'>"                       . "\n";
           $i = 1;         
           foreach ($results as $result) {
           $out .=   "     <div $style> "                                . "\n";
           $thequote = str_replace('\\', '', $result->quote);
           $out .=   "     {$thequote}<br/>"                             . "\n";
           $theauthor = str_replace(' ', '%20', $result->author);
           $out .=   "     <div><span style='padding-top: 5px; padding-bottom: 100px; float: right; color:{$textcolor}; font-size={$fontsize}px; font-style: italic;  text-decoration: none; border-bottom: 0px; padding-right: 60px;'>"      . "\n";
           $out .=   "     <a href='https://en.wikipedia.org/wiki/{$theauthor}' target='_blank'> {$result->author} </a></span></div></div>"                                                     . "\n";
           $i++;
           };
           $out .=   "   </div>"                        . "\n";
           $out .=   " </div>"                          . "\n";
           return $out;
        }
    }
    add_shortcode('GreatQuotes','gq_GreatQuotes_func');
    add_action('activate_great-quotes/great-quotes.php', array(&$gq_quoteRotator, 'createDatabaseTable'));
    add_action('deactivate_great-quotes/great-quotes.php', array(&$gq_quoteRotator, 'deleteDatabaseTable'));
    add_action('init', 'gq_includejquery');
    add_action('init', 'gq_process_post');
    add_action('admin_menu', 'gq_managementInit');
    add_action('plugins_loaded', 'gq_widgetInit');

endif;
